<?php

require_once("binary.php");
require_once("write_bmp.php");

function dec($f,$si){
   $out=str_repeat("\x00",$si); $o=0;
   $p=0; $ln=strlen($f);
   while($p<$ln and $o<$si){
      $c=getch($f,$p);
      if($c=="{"){
         $c=getch($f,$p); $n=getint1($f,$p); $n++;
         for($i=0;$i<$n;$i++) $out[$o++]=$c;
      }else{
         $out[$o++]=$c;
      }
   }
   return $out;
}

function transpose($f,$wh,$hh){
   $si=$wh*$hh;
   $out=str_repeat("\x00",$si);
   $p=0;
   for($x=0;$x<$wh;$x++){
      $o=$x;
      for($y=0;$y<$hh;$y++){
         $out[$o]=$f[$p++]; $o+=$wh;
      }
   }
   return $out;
}

function do1($fni,$fnd){
   $f=file_get_contents($fni);
   $p=0;
   $ads=array();
   for(;;){
      $id=getint2($f,$p);
      $ad=getint2($f,$p);
      $ads[]=array($id,$ad);
      if($id==0xFFFF) break;
      if($id>>8!=1) print "IDHI!=1";
   }
//print_r($ads);
   $f=file_get_contents($fnd);
   $p=0;
   $n=count($ads)-1;
/*   $pal="\x00\x00\x00\x00".
        "\xFF\xFF\x55\x00".
        "\xFF\x55\xFF\x00".
        "\xFF\xFF\xFF\x00";*/
//   mkdir($fno);
   for($i=0;$i<$n;$i++){
      $id=$ads[$i][0];
      $sa=$ads[$i][1]; $ea=$ads[$i+1][1];
      $ln=$ea-$sa;
      $dt=substr($f,$sa,$ln); $id=$id&0xFF;
      //$ofn=$fno."/res".s2($id&0xFF,3);
      //$fp=fopen($ofn,"wb"); fwrite($fp,$dt); fclose($fp);
      $p=0; $wb=getint1($dt,$p); $wh=$wb<<2; $hh=getint1($dt,$p);
      $uk=getint1($dt,$p); if($uk!=1) print "UK!=1";
      $dt=substr($dt,$p); $dt=dec($dt,$wb*$hh); $dt=transpose($dt,$wb,$hh);
      $ims[$id]=array($wb,$hh,$dt);
      //write_bmp($ofn.".bmp",$wh,$hh,$dt,$pal,2,false,$wb);
   }
   return $ims;
}

$id=opendir("kar");
$ims=array();
while($fn=readdir($id)){
   $fn=strtolower($fn);
   if(substr($fn,-4)==".dat"){
      $ims[substr($fn,0,strlen($fn)-4)]=do1("kar/".substr($fn,0,strlen($fn)-4).".ind","kar/".$fn);
   }
}
closedir($id);

@mkdir("outf_m");

$pal="\x00\xFF\x00\x00"."\x00\x00\xFF\x00"."\x00\x00\xFF\x00"."\x00\x00\xFF\x00".
     "\x00\x00\xFF\x00"."\x00\x00\xFF\x00"."\x00\x00\xFF\x00"."\x00\x00\xFF\x00".
     "\x00\x00\xFF\x00"."\x00\x00\xFF\x00"."\x00\x00\xFF\x00"."\x00\x00\xFF\x00".
     "\x00\x00\x00\x00"."\xFF\xFF\x55\x00"."\xFF\x55\xFF\x00"."\xFF\xFF\xFF\x00";

foreach($ims as $k=>$v){
   if($k[1]=="s"){
      $fno="outf_m/".$k;
      @mkdir($fno);
      $km=$k; $km[1]="m"; $vm=$ims[$km];
      foreach($v as $id=>$l){
         list($wb,$hh,$dt)=$l;
         $wh=$wb<<2;
         $ofn=$fno."/res".s2($id&0xFF,3);
         if(isset($vm[$id])){
            list($mwb,$mhh,$mdt)=$vm[$id];
            if($mwb!=$wb or $mhh!=$hh) printf("Mask has wrong size! FILE=%s ID=%d WB=%d HH=%d MWB=%d MHH=%d\r\n",$k,$id,$wb,$hh,$mwb,$mhh);
         }else{
            $mwb=$mhh=0; //$mdt=str_repeat("\xFF",strlen($dt));
         }
         //$dt=convbpp($dt)|convbpp($mdt)<<2;
         $out="";
         for($y=0;$y<$hh or $y<$mhh;$y++){
            for($x=0;$x<$wb or $x<$mwb;$x++){
               if($x<$wb and $y<$hh) $dc=ord($dt[$y*$wb+$x]); else $dc=0x00;
               if($x<$mwb and $y<$mhh) $mdc=ord($mdt[$y*$mwb+$x]); else $mdc=0xFF;
               for($i=6;$i>=0;$i-=2){
                  $px=($dc>>$i)&3; $mpx=($mdc>>$i)&3; $oc=($mpx<<2)|$px; $oc&=15;
                  if($i&2) $a=$oc<<4; else { $a|=$oc; $out.=chr($a); }
               }
            }
         }
         if($mwb>$wb) $wb=$mwb; $wh=$wb<<2;
         write_bmp($ofn.".bmp",$wh,$hh,$out,$pal,4,false,$wb*2);
      }
   }
}

