<?php

require_once("binary.php");
require_once("write_bmp.php");

function dec($f,$si){
   $out=str_repeat("\x00",$si); $o=0;
   $p=0; $ln=strlen($f);
   while($p<$ln and $o<$si){
      $c=getch($f,$p);
      if($c=="{"){
         $c=getch($f,$p); $n=getint1($f,$p); $n++;
         for($i=0;$i<$n;$i++) $out[$o++]=$c;
      }else{
         $out[$o++]=$c;
      }
   }
   return $out;
}

function transpose($f,$wh,$hh){
   $si=$wh*$hh;
   $out=str_repeat("\x00",$si);
   $p=0;
   for($x=0;$x<$wh;$x++){
      $o=$x;
      for($y=0;$y<$hh;$y++){
         $out[$o]=$f[$p++]; $o+=$wh;
      }
   }
   return $out;
}

function do1($fni,$fnd,$fno){
   $f=file_get_contents($fni);
   $p=0;
   $ads=array();
   for(;;){
      $id=getint2($f,$p);
      $ad=getint2($f,$p);
      $ads[]=array($id,$ad);
      if($id==0xFFFF) break;
      if($id>>8!=1) print "IDHI!=1";
   }
//print_r($ads);
   $f=file_get_contents($fnd);
   $p=0;
   $n=count($ads)-1;
   $pal="\x00\x00\x00\x00".
        "\xFF\xFF\x55\x00".
        "\xFF\x55\xFF\x00".
        "\xFF\xFF\xFF\x00";
   mkdir($fno);
   for($i=0;$i<$n;$i++){
      $id=$ads[$i][0];
      $sa=$ads[$i][1]; $ea=$ads[$i+1][1];
      $ln=$ea-$sa;
      $dt=substr($f,$sa,$ln);
      $ofn=$fno."/res".s2($id&0xFF,3);
      $fp=fopen($ofn,"wb"); fwrite($fp,$dt); fclose($fp);
      $p=0; $wb=getint1($dt,$p); $wh=$wb<<2; $hh=getint1($dt,$p);
      $uk=getint1($dt,$p); if($uk!=1) print "UK!=1";
      $dt=substr($dt,$p); $dt=dec($dt,$wb*$hh); $dt=transpose($dt,$wb,$hh);
      write_bmp($ofn.".bmp",$wh,$hh,$dt,$pal,2,false,$wb);
   }
}

mkdir("outf");
$id=opendir("kar");
while($fn=readdir($id)){
   if(substr(strtolower($fn),-4)==".dat") do1("kar/".substr($fn,0,strlen($fn)-4).".ind","kar/".$fn,"outf/".$fn."/");
}
closedir($id);

